;;  ------------------------------------------------------------------------
;; |   FILE           :  list-index.rkt                                     |
;; |   AUTHOR         :  Eugene Wallingford                                 |
;; |   CREATION DATE  :  2022/03/31                                         |
;; |   DESCRIPTION    :  list-index returns the 0-based position of an      |
;; |                     item in a list, or -1 if not found.  We discussed  |
;; |                     this function in Session 17 when learning letrec.  |
;;  ------------------------------------------------------------------------

#lang racket
(provide list-index)

(define list-index
  (lambda (target los)
    (letrec ((list-index-helper
               (lambda (los base)
                 (cond ((null? los) -1)
                       ((eq? target (first los)) base)
                       (else (list-index-helper (rest los) (add1 base)))))))
      (list-index-helper los 0))))

;; ----- END OF FILE -------------------------------------------------------
